// Auto-generated. Do not edit!

// (in-package pr2_common_action_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let sensor_msgs = _finder('sensor_msgs');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class ArmMoveIKGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.pose = null;
      this.tool_frame = null;
      this.ik_seed = null;
      this.ik_timeout = null;
      this.move_duration = null;
    }
    else {
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('tool_frame')) {
        this.tool_frame = initObj.tool_frame
      }
      else {
        this.tool_frame = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('ik_seed')) {
        this.ik_seed = initObj.ik_seed
      }
      else {
        this.ik_seed = new sensor_msgs.msg.JointState();
      }
      if (initObj.hasOwnProperty('ik_timeout')) {
        this.ik_timeout = initObj.ik_timeout
      }
      else {
        this.ik_timeout = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('move_duration')) {
        this.move_duration = initObj.move_duration
      }
      else {
        this.move_duration = {secs: 0, nsecs: 0};
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ArmMoveIKGoal
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [tool_frame]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.tool_frame, buffer, bufferOffset);
    // Serialize message field [ik_seed]
    bufferOffset = sensor_msgs.msg.JointState.serialize(obj.ik_seed, buffer, bufferOffset);
    // Serialize message field [ik_timeout]
    bufferOffset = _serializer.duration(obj.ik_timeout, buffer, bufferOffset);
    // Serialize message field [move_duration]
    bufferOffset = _serializer.duration(obj.move_duration, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ArmMoveIKGoal
    let len;
    let data = new ArmMoveIKGoal(null);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [tool_frame]
    data.tool_frame = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [ik_seed]
    data.ik_seed = sensor_msgs.msg.JointState.deserialize(buffer, bufferOffset);
    // Deserialize message field [ik_timeout]
    data.ik_timeout = _deserializer.duration(buffer, bufferOffset);
    // Deserialize message field [move_duration]
    data.move_duration = _deserializer.duration(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.pose);
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.tool_frame);
    length += sensor_msgs.msg.JointState.getMessageSize(object.ik_seed);
    return length + 16;
  }

  static datatype() {
    // Returns string type for a message object
    return 'pr2_common_action_msgs/ArmMoveIKGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '659cdac4f142756518faf4644a34bdda';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # the desired pose of the tool frame
    geometry_msgs/PoseStamped pose
    
    # tool frame defauts to x_wrist_roll_link
    geometry_msgs/PoseStamped tool_frame
    
    # the joint space configuration to resolve redundancy
    sensor_msgs/JointState ik_seed
    
    duration ik_timeout
    duration move_duration
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: sensor_msgs/JointState
    # This is a message that holds data to describe the state of a set of torque controlled joints. 
    #
    # The state of each joint (revolute or prismatic) is defined by:
    #  * the position of the joint (rad or m),
    #  * the velocity of the joint (rad/s or m/s) and 
    #  * the effort that is applied in the joint (Nm or N).
    #
    # Each joint is uniquely identified by its name
    # The header specifies the time at which the joint states were recorded. All the joint states
    # in one message have to be recorded at the same time.
    #
    # This message consists of a multiple arrays, one for each part of the joint state. 
    # The goal is to make each of the fields optional. When e.g. your joints have no
    # effort associated with them, you can leave the effort array empty. 
    #
    # All arrays in this message should have the same size, or be empty.
    # This is the only way to uniquely associate the joint name with the correct
    # states.
    
    
    Header header
    
    string[] name
    float64[] position
    float64[] velocity
    float64[] effort
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ArmMoveIKGoal(null);
    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.PoseStamped.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.tool_frame !== undefined) {
      resolved.tool_frame = geometry_msgs.msg.PoseStamped.Resolve(msg.tool_frame)
    }
    else {
      resolved.tool_frame = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.ik_seed !== undefined) {
      resolved.ik_seed = sensor_msgs.msg.JointState.Resolve(msg.ik_seed)
    }
    else {
      resolved.ik_seed = new sensor_msgs.msg.JointState()
    }

    if (msg.ik_timeout !== undefined) {
      resolved.ik_timeout = msg.ik_timeout;
    }
    else {
      resolved.ik_timeout = {secs: 0, nsecs: 0}
    }

    if (msg.move_duration !== undefined) {
      resolved.move_duration = msg.move_duration;
    }
    else {
      resolved.move_duration = {secs: 0, nsecs: 0}
    }

    return resolved;
    }
};

module.exports = ArmMoveIKGoal;
